
(new)

(set-message-level 1)
;;---------------------- B. PLAQUE -------------------------------
;; B.1. Paramtres physiques plaque 


(setq my-plate
      (set-pitch 
       (make-object 'clamped-circ-plate 
; (modes 300)
                    (modes 30)
                    (thickness .01)
                    (freq-loss .1) 
                    (const-loss 1) 
                    (young 3.1e5)
                    (poisson .27)
                   (density 3200))
'radius 100)
   ;    'radius (/ 1 100))
)


;;---------------------- B. PLAQUE -------------------------------




;;---------------------- A. MARTEAU ------------------------------

;; A.1. Paramtres physiques du marteau
;; const. controlers 9  16

(defvar my-point)
(setq my-point (make-object 'single-point))



;; B.2. Accs Input Plaque

;; make plate input
(defvar my-plate-hit)
(setq my-plate-hit (make-access my-plate (const .8 0) 'normal)) ;  Distance par rapport au centre uniquement dans la doc. Doit tre spcifi mais ignor. 


;; A.2. Sortie Marteau
;; => Output 'Felt Connection

(defvar my-point-hit);; make hammer output
(setq my-point-hit (make-access my-point (const 0) 'normal))

(defvar my-point-mov)
(setq my-point-mov (make-access my-point (const 1) 'normal))



;; C. FELT Connection (static params, controled externally in Max)

(make-connection 'felt my-plate-hit .0  my-point-hit .5  (const .00001) (const 1e+9) (const 2.5) (const 0.83) (const 0.0035) (const 1)) 


;;---------------------- A. MARTEAU ------------------------------
;; A.2. Entre Sortie Marteau

;;; make position connection to push hammer




(defvar my-point-mov)
(setq my-point-mov (make-access my-point (const 0) 'normal)) ;;mlys: dynamic controler 8 hammer @access-in-1-position a priori pas dynamique
;; contrle du niveau d'entre sonore
(make-connection 'position my-point-mov
         
                                 (make-controller 'envelope 1
                                  (list (list 0.0  .5)
                                        (list .01  -0.01)
                                        (list .02  .5)
                                        (list 1.5   .5)
                                        (list 1.51 -0.01)
                                        (list 1.52 .5)                                     
                                  )))

;;  dynamic controler 9, hammer @access-out-1-position


;;make listening point


(defvar my-plate-out)
(setq my-plate-out (make-access my-plate (const .9 0) 'normal))

(defvar my-plate1-out)
(setq my-plate1-out (make-access my-plate (const .9 90) 'normal))



(make-point-output my-plate-out)

(make-point-output my-plate1-out)


(defvar graph)
(setq graph (make-plot))
(plot-value graph "point mov"  (make-controller 'access-position 1 my-point-mov))
(plot-value graph "point tip"  (make-controller 'access-position 1 my-point-hit))

(plot-value graph "plate tip"  (make-controller 'access-position 1 my-plate-hit))


;;;
;;; arrange the plot, run the synthesis and play the sound
;;;

(run 20)

(plot graph "hammered plate (example 2)" 0 0. .1 -.1 .1)
(play)